import { FanOut } from 'thingies/es2020/fanout';
import { VecNode, ConNode, ObjNode, ArrNode, BinNode, StrNode, ValNode } from '../../nodes';
import { ApiPath, ArrApi, BinApi, ConApi, NodeApi, ObjApi, StrApi, VecApi, ValApi } from './nodes';
import { Emitter } from '../../../util/events/Emitter';
import { Patch } from '../../../json-crdt-patch/Patch';
import { PatchBuilder } from '../../../json-crdt-patch/PatchBuilder';
import { ModelChangeType, type Model } from '../Model';
import { SyncStore } from '../../../util/events/sync-store';
import type { JsonNode, JsonNodeView } from '../../nodes';
export interface ModelApiEvents {
    change: CustomEvent<Set<ModelChangeType>>;
    flush: CustomEvent<Patch>;
}
export declare class ModelApi<N extends JsonNode = JsonNode> implements SyncStore<JsonNodeView<N>> {
    readonly model: Model<N>;
    builder: PatchBuilder;
    next: number;
    constructor(model: Model<N>);
    readonly changes: FanOut<ModelChangeType>;
    private queuedChanges;
    private readonly queueChange;
    private et;
    get events(): Emitter<ModelApiEvents>;
    wrap(node: ValNode): ValApi;
    wrap(node: StrNode<any>): StrApi;
    wrap(node: BinNode): BinApi;
    wrap(node: ArrNode): ArrApi;
    wrap(node: ObjNode): ObjApi;
    wrap(node: ConNode): ConApi;
    wrap(node: VecNode): VecApi;
    wrap(node: JsonNode): NodeApi;
    get r(): ValApi<import("../../nodes").RootNode<N>>;
    get node(): import("./types").JsonNodeApi<N>;
    in(path?: ApiPath): ValApi<ValNode<any>>;
    find(path?: ApiPath): JsonNode<unknown>;
    val(path?: ApiPath): ValApi<ValNode<any>>;
    vec(path?: ApiPath): VecApi<VecNode<any>>;
    str(path?: ApiPath): StrApi;
    bin(path?: ApiPath): BinApi;
    arr(path?: ApiPath): ArrApi<ArrNode<any>>;
    obj(path?: ApiPath): ObjApi<ObjNode<any>>;
    const(path?: ApiPath): ConApi<ConNode<any>>;
    root(json: unknown): this;
    apply(): void;
    advance(): void;
    view(): Readonly<JsonNodeView<N>>;
    flush(): Patch;
    readonly subscribe: (callback: () => void) => () => void;
    readonly getSnapshot: () => any;
}
