import { FanOut, FanOutListener } from 'thingies/es2020/fanout';
import { Emitter } from '../../../util/events/Emitter';
import type { JsonNode, JsonNodeView } from '../../nodes';
import type { SyncStore, SyncStoreUnsubscribe } from '../../../util/events/sync-store';
import type { NodeApi } from './nodes';
export interface NodeEventMap {
    view: CustomEvent<void>;
}
declare class ChangesFanOut<N extends JsonNode = JsonNode> extends FanOut<JsonNodeView<N>> {
    private readonly api;
    private _v;
    private _u;
    constructor(api: NodeApi<N>);
    listen(listener: FanOutListener<JsonNodeView<N>>): () => void;
    dispose(): void;
}
export declare class NodeEvents<N extends JsonNode = JsonNode> extends Emitter<NodeEventMap> implements SyncStore<JsonNodeView<N>> {
    private readonly api;
    readonly changes: ChangesFanOut<N>;
    constructor(api: NodeApi<N>);
    private viewSubs;
    private _view;
    private onModelChange;
    private setupViewEvents;
    on<K extends keyof NodeEventMap>(type: K, listener: (ev: NodeEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
    off<K extends keyof NodeEventMap>(type: K, listener: (ev: NodeEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
    onDelete(): void;
    readonly subscribe: (callback: () => void) => SyncStoreUnsubscribe;
    readonly getSnapshot: () => JsonNodeView<N>;
}
export {};
